SMCSS(8)

NAME
smcss - print information about the AF_SMC sockets and link groups

SYNOPSIS

smcss [--debug|-d] [--smcd|-D] [--wide|-W]

smcss {--all|-a} [--debug|-d] [--smcd|-D] [--wide|-W]

smcss [--debug|-d] [--smcr|-R] [--wide|-W]

smcss {--all|-a} [--debug|-d] [--smcr|-R] [--wide|-W]

smcss {--listening|-l} [--wide|-W]

smcss {--version|-v}

smcss {--help|-h}

DESCRIPTION

smcss prints information about the Linux AF_SMC sockets and link groups. The type of information printed is controlled by the first argument, as follows:

(none)
    displays a list of connecting, closing, or connected SMC sockets with basic information.

-a, --all
    displays all types of SMC sockets: listening, opening, closing, and connected.

-l, --listening
    shows listening sockets only. These are omitted by default.

OPTIONS

-d, --debug
    displays additional debug information, such as shutdown state.

-D, --smcd
    displays additional SMC-D specific information. Shows SMC-D sockets only.

-h, --help
    displays usage information.

-R, --smcr
    displays additional SMC-R specific information. Shows SMC-R sockets only.

-v, --version
    displays program version.

-W, --wide
    do not truncate IP addresses.

OUTPUT

  State
The state of the socket. The state can be one of these values:

INIT
    The SMC socket is being initialized. It is not connected nor listening yet.

CLOSED
    The SMC socket is closed. It is not connected nor listening anymore.

LISTEN
    The SMC socket is a listening socket, waiting for incoming connection requests.

ACTIVE
    The SMC socket has an established connection. In this state, the TCP connection is fully established, rendezvous processing has been completed, and SMC peers can exchange data via RDMA.

PEERCLW1
    No further data will be sent to the peer.

PEERCLW2
    No further data will be sent to or received from the peer.

APPLCLW1
    No further data will be received from the peer.

APPLCLW2
    No further data will be received from or sent to the peer.

APPLFINCLW
    The peer has closed the socket.

PEERFINCLW
    The socket is closed locally.

PEERABORTW
    The socket was abnormally closed locally.

PROCESSABORT
    The peer has closed the socket abnormally.

  UID
User ID of the SMC socket.

  Inode
Inode attribute of the socket.

  Local Address
Address and port number of the local end of the SMC socket. The displayed address is truncated when it ends with '..'. -W, --wide can be used to display addresses untruncated.

  Peer Address
Address and port number of the remote end of the socket. Analogous to "Local Address".

  Intf
When the socket is explicitly bound with setsockopt option SO_BINDTODEVICE then Intf shows the interface number of the Ethernet device to which the socket is bound.

  Mode

SMCD
    The SMC socket uses SMC-D for data exchange.

SMCR
    The SMC socket uses SMC-R for data exchange.

TCP The SMC socket uses the TCP protocol for data exchange, because an SMC connection could not be established.

In case of an error during connection setup, respective error codes will be displayed in the format <local>/<remote>.

Linux error codes:

0x01010000
    Out of memory

0x02010000
    Timeout while waiting for confirm link message over RDMA device

0x02020000
    Timeout while waiting for RDMA device to be added

0x03000000
    Configuration error

0x03010000
    Peer does not support SMC

0x03020000
    Connection uses IPsec

0x03030000
    No SMC devices found (R and D)

0x03030001
    No ISM device for SMC-D found

0x03030002
    No RDMA device for SMC-R found

0x03030003
    Hardware has no ISMv2 support

0x03030004
    Peer sent no SMCv2 extension

0x03030005
    Peer sent no SMC-Dv2 extension

0x03030006
    Peer sent no ISMv2 SEID

0x03030007
    No SMC-Dv2 device found, but required

0x03030008
    Peer sent no UEID

0x03040000
    SMC modes mismatch (R or D)

0x03050000
    Peer has eyecatcher in RMBE

0x03060000
    Fastopen sockopt not supported

0x03070000
    IP prefix / subnet mismatch

0x03080000
    Error retrieving VLAN ID of IP device

0x03090000
    Error while registering VLAN ID on ISM device

0x030a0000
    No active SMC-R link in link group

0x030b0000
    SMC-R link from server not found

0x030c0000
    SMC version mismatch

0x030d0000
    SMC-D connection limit reached

0x030e0000
    SMC-Rv2 connection found no route to peer

0x030f0000
    SMC-Rv2 connection mismatch direct/indirect with peer 0x04000000 Synchronization error

0x05000000
    Peer declined during handshake

0x09990000
    Internal error

0x09990001
    rtoken handling failed

0x09990002
    RDMA link failed

0x09990003
    RMB registration failed

  ShutD

<-> The SMC socket has not been shut down.

R-> The SMC socket is shut down one-way and cannot receive data.

<-W The SMC socket is shut down one-way and cannot send data.

R-W The SMC socket is shut down in both ways and cannot receive or send data.

  Token
Unique ID of the SMC socket connection.

  Sndbuf
Size of the to-be-sent window of the SMC socket connection.

  Rcvbuf
Size of the receiving window of the SMC socket connection (filled by peer).

  Peerbuf
Size of the peer receiving window of the SMC socket connection (to fill during RDMA-transfer).

  rxprod-Cursor
Describes the current cursor location of the "Rcvbuf" for data to be received from the peer.

  rxcons-Cursor
Describes the current cursor location of the "Peerbuf" for data sent to peer and confirmed by the peer.

  rxFlags
SMC socket connection flags set by and received from the peer.

  txprod-Cursor
Describes the current cursor location of the "Peerbuf" for data sent to peer.

  txcons-Cursor
Describes the current cursor location of the "Rcvbuf" for data received from the peer and confirmed to the peer.

  txFlags
SMC socket connection flags set locally and sent to the peer.

  txprep-Cursor
Describes the current cursor location of the "Sndbuf" for data to be sent. The data is to be moved to the "Peerbuf".

  txsent-Cursor
Describes the current cursor location of the "Sndbuf" for data sent. The data was moved to the "Peerbuf".

  txfin-Cursor
Describes the current cursor location of the "Sndbuf" for data sent and send completion confirmed. The data was moved to the "Peerbuf" and completion was confirmed.

  Role

CLNT
    The link group of the SMC socket is used for client connections.

SERV
    The link group of the SMC socket is used for server connections.

  IB-Device
Name of the RoCE device used by the link group to which the SMC socket belongs.

  Port
Port of the RoCE device used by the link group to which the SMC socket belongs.

  Linkid
Unique link ID of the link within the link group to which the SMC socket belongs.

  GID
Gid of the RoCE port used by the link group to which the SMC socket belongs.

  Peer-GID
Gid of the Foreign RoCE port used by the link group to which the SMC socket belongs.

  VLAN
tbd.

RETURN CODES
Successful smcss commands return 0 and display the requested socket state table or link group information. If an error occurs, smcss writes a message to stderr and completes with a return code other than 0.

SEE ALSO
af_smc(7), smc_chk(8) smc_rnics(8), smc_run(8), smc_pnet(8), smcd(8), smcr(8)